/*about.js
File contenente le funzioni necessarie al corretto funzionamento della finestra relativa
alle informazioni sull'add-on, permette di individuare la versione dell'add-on e di avviare link sul browser.
*/

var ABOUT = {

  //trova la versione dell'add-on
  trovaVersione: function() {
    //determina la textbox read-only nascosta da riempire col valore trovato
    var versionField = document.getElementById("version");
    //preleva il riferimento all'extension manager di firefox
    var extensionManager = Components.classes["@mozilla.org/extensions/manager;1"].getService(Components.interfaces.nsIExtensionManager);
    //preleva il riferimento all'add-on con un certo ID
    var item = extensionManager.getItemForID("{3eb050d0-dfe9-11de-8a39-0800200c9a66}");
    //dai dati estrai la versione
    versionField.value=item.version;
    //il testo inserito, viene allineato
    versionField.parentNode.setAttribute("align", "baseline");
  },
  
  /*permette di caricare nel browser la pagina indicata dall'url, se l'url  un indirizzo e-mail,
    allora viene caricato il gestore di e-mail di deafult e la pagina aperta viene chiusa subito.
  */
  loadInBrowser: function(url,mail) { //mail pu valere 0 o 1(se  un indirizzo e-mail)
     //preleva il riferimento al window mediator di firefox
     var windowMediator=Components.classes["@mozilla.org/appshell/window-mediator;1"] 
         .getService(Components.interfaces.nsIWindowMediator); 
     //preleva il riferimento alla finestra corrente di firefox
     var currentWindow=windowMediator.getMostRecentWindow("navigator:browser"); 
     if (currentWindow) { //se esiste
         try { 
             currentWindow.delayedOpenTab(url); 
         } 
         catch(e) { 
             currentWindow.loadURI(url);
         } 
         if(mail)//se  una mail, allora chiudi il tab aperto perch non serve
            currentWindow.getBrowser().removeCurrentTab();  
     } 
     else { 
         var protocolService=Components.classes["@mozilla.org/uriloader/external-protocol-service;1"] 
         .getService(Components.interfaces.nsIExternalProtocolService); 
         protocolService.loadUrl(url); 
     } 
  }
} 
 
